#define BLYNK_PRINT Serial
#include <SPI.h> //library serial perpheral interface
#include <Wire.h> //library wiring
#include <ESP8266WiFi.h> //library esp8266 wifi
#include <BlynkSimpleEsp8266.h>
#include <DHT.h> //library dht
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd2(0x27, 16, 2);

char auth[] = "Hi_PNc_WAYizZOsFmfyYk4LAVx1qM4dd"; //token dari blynk
char ssid[] = "AndroidAP3A4D";
char pass[] = "bismillah";

#define DHTPIN 0
//#define DHTPIN 2
#define DHTTYPE DHT22     // DHT 11
DHT dht(DHTPIN, DHTTYPE);

const int pinSoil = A0;
int pinRelay = D4; // deklarasi pin D7 nodemcu untuk pin data relay 
BlynkTimer timer;

void setup()
{
  // Debug console
  Serial.begin(115200);
  dht.begin();
  //Blynk.begin(auth, ssid, pass);
  // You can also specify server:
  Blynk.begin(auth, ssid, pass, "blynk-cloud.com", 80);
  //Blynk.begin(auth, ssid, pass, IPAddress(192,168,1,100), 8080);
  timer.setInterval(1000L, sendSensor);
  pinMode(pinRelay, OUTPUT); // deklarasi relay sebagai output
  //digitalWrite(pinRelay, LOW );
  lcd2.begin();
  lcd2.backlight();
  lcd2.clear();
  lcd2.setCursor(0, 0);
  lcd2.print("MONITORING");
  lcd2.setCursor(0, 1);
  lcd2.print("TANAMAN ZINNIA");
  delay(10000);
}

void sendSensor()
{
  float h = dht.readHumidity(); //dht membaca kelembapan, dan h adalah variabel tipe data float
  float t = dht.readTemperature(); // or dht.readTemperature(true) for Fahrenheit
  if (isnan(h) || isnan(t)) 
  {
    Serial.println("Failed to read from DHT sensor!"); //jika pembacaan dari sensor dht11 gagal atau tidak terkoneksikan maka muncul tulisan......
    return;
  }
  
  float persentase_kelembapan_tanah;
  int sensor_analog;
  sensor_analog = analogRead(pinSoil);
  persentase_kelembapan_tanah = map(sensor_analog, 0, 1023, 0, 100);
  Serial.print("Kelembapan Tanah = ");
  Serial.print(persentase_kelembapan_tanah);
  Serial.println("%");
  Serial.print("Nilai Analog = ");
  Serial.println(sensor_analog);
  Serial.print("Suhu Udara = ");
  Serial.print(t);
  Serial.println("°C");
  Serial.print("Kelembapan Udara = ");
  Serial.print(h);
  Serial.println("%");
  lcd2.clear();
  lcd2.setCursor(0, 0);
  lcd2.print("SUHU : ");
  lcd2.print((float)t);
  lcd2.print((char)223); // simbol derajat
  lcd2.print("C");
  lcd2.setCursor(0, 1);
  lcd2.print("SOIL : ");
  lcd2.print((float)persentase_kelembapan_tanah);
  lcd2.print("%");
  Blynk.virtualWrite(V5, h);// pin virtual pembacaan kelembapan udara virtual pada apk blynk 
  Blynk.virtualWrite(V6, t); // pin virtual pembacaan suhu virtual pada apk blynk
  Blynk.virtualWrite(V1, persentase_kelembapan_tanah);
  delay(1000);

  if ((t >= 25) && (persentase_kelembapan_tanah >= 80)) // jika suhu udara lebih dari sama dengan 35 derajat celcius dan kelembapan tanah lebih dari sama dengan 80 persen maka
      {
        Blynk.notify("TANAH KERING, POMPA AIR NYALA!!!"); 
        digitalWrite(pinRelay, LOW); // relay akan kondisi high selama 5 detik dan menyemprotkan air ke tanaman
        delay(10000); // delay 10 detik ketika relay high maka pompa akan menyemprotkan air ke tanaman
        digitalWrite(pinRelay, HIGH); // ketika lebih dari 5 detik maka relay otomatis kondisi low dan pompa otomatis mati
      }
  else
      {
         //Blynk.notify("hahaha"); 
      }
}

void loop()
{
  Blynk.run();
  timer.run();
}
